const {ccclass, property} = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    @property(cc.Node)
    broadcastNode: cc.Node = null;

    broadcastLabel: cc.RichText = null;

    @property(cc.Node)
    maskNode: cc.Node = null;

    speed: number = 8;//这里配置的是相对跑马灯遮罩的宽度来说的， 当前也就是1220宽度跑8秒跑完
    runSpeedWidth: number = null;//跑8秒的宽度

    onLoad():void{
       this.broadcastLabel = this.broadcastNode.getComponent(cc.RichText);
       this.runSpeedWidth = this.maskNode.width;
       this.scrollStart();
    }

        /**
     * 滚动跑马灯
     */
    scrollStart():void{
        this.broadcastLabel.string = this.getRandString();

        this.broadcastNode.x = this.maskNode.width / 2;

        let actionComplete = cc.callFunc(this.scrollComplete.bind(this));
        let delayShowNextTime = cc.delayTime(1);

        let targetPosX = this.maskNode.width / 2 + this.maskNode.width;
        let targetPos = cc.v2(-targetPosX, 0);
        let scrollSecond = Math.floor(this.maskNode.width / this.runSpeedWidth * this.speed);
        if (scrollSecond < 8) {
            scrollSecond = 8;
        }
        this.broadcastNode.runAction(cc.sequence(cc.moveTo(scrollSecond, targetPos), delayShowNextTime, actionComplete));
    }

        /**
     * 滚动完成
     */
    scrollComplete():void{
        this.scheduleOnce(()=>{
            this.scrollStart();
        },1);
    }

    public  getIntRandom(start, end): number {
        return start + Math.round(Math.random() * (end - start));
    }

    getRandString():string{
        let randVip = this.getIntRandom(0,10);
        let vipStr = "<img src=\"vip_text_" +  + randVip + "\"/>  ";

        let userName = "玩家"+new Date().getTime();
        let userNameStr = this.getTextRtStyle(userName, "#fe724d", "#fe724d", 28);
        
        let gameName = "游戏"+this.getIntRandom(1,10);
        let gameNameStr = this.getTextRtStyle(gameName, "fff55a", "fff55a", 28);

        let result = this.getIntRandom(0,49);
        let resultStr = "<img src=\"game_result" +result + "\"/>  ";

        let coin = this.getIntRandom(100,100000);
        let coinStr = this.getCoinRtStyle(coin.toFixed(2));

        return vipStr+userNameStr+"在"+gameNameStr+"拿到"+resultStr+"，赢得"+coinStr;

    }

    getTextRtStyle(text: string, outLineColor: string = "#ffffff", textColor: string = "#ffffff", fontSize: number = 28, outLineWidth: number = 1) {
        if (!text) {
            return;
        }

        return `<outline color=${outLineColor} width=${outLineWidth}><size=${fontSize}><color=${textColor}>${text}</c></s></outline>`;
    }

    getCoinRtStyle(coin: string) {
        if (!coin) {
            return;
        }
        let numRt = "";
        for (let index = 0; index < coin.length; ++index) {
            let strItem = coin[index];
            if (strItem === ".") {
                numRt = numRt + "<img src=\"num_font_dian\"/>";
                continue;
            }
            numRt = numRt + "<img src=\"num_font_0" + strItem + "\"/>";
        }
        numRt = numRt + "<img src=\"yuan_text\"/>";
        return numRt;
    }
}
