"use strict";
cc._RF.push(module, 'e1b90/rohdEk4SdmmEZANaD', 'Helloworld');
// Script/Helloworld.ts

Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Helloworld = /** @class */ (function (_super) {
    __extends(Helloworld, _super);
    function Helloworld() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.broadcastNode = null;
        _this.broadcastLabel = null;
        _this.maskNode = null;
        _this.speed = 8; //这里配置的是相对跑马灯遮罩的宽度来说的， 当前也就是1220宽度跑8秒跑完
        _this.runSpeedWidth = null; //跑8秒的宽度
        return _this;
    }
    Helloworld.prototype.onLoad = function () {
        this.broadcastLabel = this.broadcastNode.getComponent(cc.RichText);
        this.runSpeedWidth = this.maskNode.width;
        this.scrollStart();
    };
    /**
 * 滚动跑马灯
 */
    Helloworld.prototype.scrollStart = function () {
        this.broadcastLabel.string = this.getRandString();
        this.broadcastNode.x = this.maskNode.width / 2;
        var actionComplete = cc.callFunc(this.scrollComplete.bind(this));
        var delayShowNextTime = cc.delayTime(1);
        var targetPosX = this.maskNode.width / 2 + this.maskNode.width;
        var targetPos = cc.v2(-targetPosX, 0);
        var scrollSecond = Math.floor(this.maskNode.width / this.runSpeedWidth * this.speed);
        if (scrollSecond < 8) {
            scrollSecond = 8;
        }
        this.broadcastNode.runAction(cc.sequence(cc.moveTo(scrollSecond, targetPos), delayShowNextTime, actionComplete));
    };
    /**
 * 滚动完成
 */
    Helloworld.prototype.scrollComplete = function () {
        var _this = this;
        this.scheduleOnce(function () {
            _this.scrollStart();
        }, 1);
    };
    Helloworld.prototype.getIntRandom = function (start, end) {
        return start + Math.round(Math.random() * (end - start));
    };
    Helloworld.prototype.getRandString = function () {
        var randVip = this.getIntRandom(0, 10);
        var vipStr = "<img src=\"vip_text_" + +randVip + "\"/>  ";
        var userName = "玩家" + new Date().getTime();
        var userNameStr = this.getTextRtStyle(userName, "#fe724d", "#fe724d", 28);
        var gameName = "游戏" + this.getIntRandom(1, 10);
        var gameNameStr = this.getTextRtStyle(gameName, "fff55a", "fff55a", 28);
        var result = this.getIntRandom(0, 49);
        var resultStr = "<img src=\"game_result" + result + "\"/>  ";
        var coin = this.getIntRandom(100, 100000);
        var coinStr = this.getCoinRtStyle(coin.toFixed(2));
        return vipStr + userNameStr + "在" + gameNameStr + "拿到" + resultStr + "，赢得" + coinStr;
    };
    Helloworld.prototype.getTextRtStyle = function (text, outLineColor, textColor, fontSize, outLineWidth) {
        if (outLineColor === void 0) { outLineColor = "#ffffff"; }
        if (textColor === void 0) { textColor = "#ffffff"; }
        if (fontSize === void 0) { fontSize = 28; }
        if (outLineWidth === void 0) { outLineWidth = 1; }
        if (!text) {
            return;
        }
        return "<outline color=" + outLineColor + " width=" + outLineWidth + "><size=" + fontSize + "><color=" + textColor + ">" + text + "</c></s></outline>";
    };
    Helloworld.prototype.getCoinRtStyle = function (coin) {
        if (!coin) {
            return;
        }
        var numRt = "";
        for (var index = 0; index < coin.length; ++index) {
            var strItem = coin[index];
            if (strItem === ".") {
                numRt = numRt + "<img src=\"num_font_dian\"/>";
                continue;
            }
            numRt = numRt + "<img src=\"num_font_0" + strItem + "\"/>";
        }
        numRt = numRt + "<img src=\"yuan_text\"/>";
        return numRt;
    };
    __decorate([
        property(cc.Node)
    ], Helloworld.prototype, "broadcastNode", void 0);
    __decorate([
        property(cc.Node)
    ], Helloworld.prototype, "maskNode", void 0);
    Helloworld = __decorate([
        ccclass
    ], Helloworld);
    return Helloworld;
}(cc.Component));
exports.default = Helloworld;

cc._RF.pop();